(import test coin-change)

(define (sum-mult solution)
  (foldl (lambda (sum denom.count)
           (+ sum (* (car denom.count) (cdr denom.count))))
         0 solution))

(define (coin-change/check has-solution? target denominations)
  (receive (solution memo) (coin-change target denominations)
    (test-assert
      (and (eq? has-solution? (not (not solution)))
           (or (not solution)
               (= target (sum-mult solution)))))))

(define-syntax test-every
  (syntax-rules ()
    ((test-every (id args ...) ...)
     (begin
       (test-assert (number->string id) (coin-change/check args ...))
       ...))))

; id has-solution? target denominations
(test-every
  (0 #t 765 '((50 . 123) (10 . 456) (5 . 789)))
  (1 #f 767 '((50 . 123) (10 . 456) (5 . 789)))
  )

(test-exit)
